!
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!.COPYRIGHT: (c) 1995 Special Astrophysical Observatory
!.IDENT    : panel.prg
!.AUTHOR   : V.Shergin
!.KEYWORDS : Standard CCD observations
!.PURPOSE  :
!      Start Tcl/Tk command panel for our CCD-observation ("NICE" MIDAS context)
!.USAGE    :
!      Execute as:
!          PANEL/NICE [PanelName]
!      where:
!          PanelName - name of panel configuration file (without .pnl ext)
!                      default - "main"
!
!.NOTES    : 1. MIDAS version >= 93NOV
!            2. Connection with 94NOV may hang
!               (problems with USR1 signal catching in prepa?)
!               use SET/BACK, CLEAR/BACK commands in this case...
!
!.VERSION  : $Header: $
!          : $Revision: $
!-------------------------------------------------------------------------
!
define/par p1 main       C "Panel_Name:"

define/local d_home/c/1/60
define/local d_mhome/c/1/60
define/local d_work/c/1/60
define/local d_serv/c/1/60
define/local panel/c/1/60   "{p1}.pnl"
define/local tkx/c/1/16     "mid_panel.tkx"
define/local ses/c/1/2      "{MID$SESS(11:12)}"

d_home  = m$symbol("HOME")
d_mhome = m$symbol("MIDASHOME")
d_serv  = "{d_home}/serv"
d_work  = "{d_home}/midwork"

!write/key gccd/c/1/60     "{d_serv}/.ccd.prg"
!write/key hccd/c/1/60     "{d_serv}/.hccd.prg"
  !
  ! If do not already use Tk - delete whole xhost list (for Tk "send" commands)
!if tk(1:1) .ne. "y" then
!  $ xhost|tail +2|xargs -l1 xhost --
!  ;
!endif

$ {tkx} {panel} {ses} &

!$ send.tcl {tkx} "reread {gccd}"
!$ send.tcl {tkx} "reread {hccd}"
