/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
.COPYRIGHT    (c)  1994  Special Astrophysical Observatory RAS
.IDENT        save_key.c
.LANGUAGE     C
.AUTHOR       Kniazev A.Yu., Laboratory "Structure"
.KEYWORDS     save some keywords with their values into special file
.PURPOSE

.COMMENT      Input : IN_A        - the file name for saving
		      INPUTC      - string with names for saving
		      INPUTI(20)  - the mode for the file (0 - create; 1 - append)

	      Output:

.VERSION      1.00  940117:   Creation by Akn
	      $Date: 1995/01/19 13:31:19 $
	      $Revision: 1.5 $
---------------------------------------------------------------------*/
#include <midas_def.h>
#include <stdio.h>
#include <string.h>

#define LENGTH  80
char text[TEXT_LEN];
char save[LENGTH], ofile[LENGTH];
char    cbuf[LENGTH];
int     ibuf[LENGTH];
float   fbuf[LENGTH];
double  dbuf[LENGTH];

main()
{
    int nval, unit, stat, null;
    FILE *of;
    char *word, type[5];
    int noelem, bytelem, i, mode=0;

    SCSPRO("save_key");

	/* Input parameters */
    stat = SCKGETC ("IN_A", 1, LENGTH, &nval, ofile);
    stat = SCKGETC ("INPUTC", 1, LENGTH, &nval, save);
    stat = SCKRDI  ("INPUTI", 20, 1, &nval, &mode, &unit, &null);

	/* Open file with 'fopen' */
    if (mode == 1) {
      if ((of = fopen (ofile, "a")) == NULL) {
	sprintf(text,"Program can't open file %s", ofile);
	SCETER(1L, text);
      }
    } else {
      if ((of = fopen (ofile, "w")) == NULL) {
	sprintf(text,"Program can't open file %s", ofile);
	SCETER(1L, text);
      }
    }

	/* Main loop */
    for (word=strtok(save, " \t"); word; word=strtok(NULL, " \t")) {
      if ((stat = SCKFND (word, type, &noelem, &bytelem)) != 0) {
	sprintf(text,"Program can't find keyword %s", word);
	SCETER(2L, text);
      }
    if (noelem > LENGTH) noelem = LENGTH;
      switch (type[0]) {
	case 'I':
	case 'i': SCKRDI (word, 1, noelem, &nval, ibuf, &unit, &null);
		  fprintf (of, "write/key %s/i/1/%d %d", word, nval, ibuf[0]);
		  for (i=1; i<nval; i++) fprintf (of, ",%d ", ibuf[i]);
		  fprintf (of, "\n");
		  break;
	case 'R':
	case 'r': SCKRDR (word, 1, noelem, &nval, fbuf, &unit, &null);
		  fprintf (of, "write/key %s/r/1/%d %e", word, nval, fbuf[0]);
		  for (i=1; i<nval; i++) fprintf (of, ",%e ", fbuf[i]);
		  fprintf (of, "\n");
		  break;
	case 'D':
	case 'd': SCKRDD (word, 1, noelem, &nval, dbuf, &unit, &null);
		  fprintf (of, "write/key %s/d/1/%d %e", word, nval, dbuf[0]);
		  for (i=1; i<nval; i++) fprintf (of, ",%e ", dbuf[i]);
		  fprintf (of, "\n");
		  break;
	case 'C':
	case 'c': SCKRDC (word, 1, 1, noelem, &nval, cbuf, &unit, &null);
		  for (i=(nval-1); i>=0; i--) {
		    if (cbuf[i] == ' ') cbuf[i] = '\0';
		    else break;
		  }
		  fprintf (of, "write/key %s/c/1/%d \"%s\"\n", word, nval, cbuf);
		  break;
	default :
		  sprintf(text,"Unknown keyword %s type", word);
		  SCETER(2L, text);
		  break;
      }
    }

	/* Close all */
    fclose(of);
    SCSEPI();
}

